# Get a Message

> Retrieve details of a specific message

## Endpoint

`GET https://qstash-{region}.upstash.io/v2/messages/{messageId}`

## Parameters

- `messageId` (path, string, required): The identifier of the message to retrieve.

## Responses

### 200 - Message details

- `messageId` (string): Unique identifier for the message
- `url` (string): The URL to which the message should be delivered.
- `topicName` (string): The URL Group (a.k.a. topic) name if this message was sent to a URL Group.
- `endpointName` (string): The endpoint name of the message if the endpoint is given a name within the URL group.
- `method` (string): The HTTP method to use for the message.
- `header` (object): The HTTP headers sent to your API.
- `body` (string): The body of the message if it is composed of utf8 chars only, empty otherwise.
- `bodyBase64` (string): The base64 encoded body if the body contains a non-utf8 char only, empty otherwise.
- `maxRetries` (integer): The number of retries that should be attempted in case of delivery failure.
- `notBefore` (integer): The unix timestamp in milliseconds before which the message should not be delivered.
- `createdAt` (integer): The unix timestamp in milliseconds when the message was created.
- `callback` (string): The url where we send a callback each time the message is attempted to be delivered.
- `failureCallback` (string): The url where we send a callback to after the message is failed
- `queueName` (string): The name of the queue if the message is enqueued to a queue.
- `scheduleId` (string): The scheduleId of the message if the message is triggered by a schedule
- `callerIP` (string): IP address of the publisher of this message.
- `label` (string): The label of the message assigned by the user. Deprecated in favor of `labels`.
- `labels` (string[]): The list of labels assigned to the message by the user.
- `flowControlKey` (string): The flow control key used for rate limiting.
- `rate` (integer): The rate value used for flow control.
- `period` (integer): The period value used for flow control.
- `parallelism` (integer): The parallelism value used for flow control.

### 404 - Message not found

- `error` (string, required): Error message

## cURL

```bash
curl --request GET \
  --url https://qstash-{region}.upstash.io/v2/messages/{messageId} \
  --header 'Authorization: Bearer <token>'
```
